﻿using C1.FlexPivot;
using C1.Win.FlexPivot;
using System;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Windows.Forms;

namespace MultipleSlicers
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Populates the DataTable with data
            OleDbConnection con = new OleDbConnection("Provider=microsoft.jet.oledb.4.0;Data source=" + "..\\..\\Sales.mdb");
            DataTable dt = new DataTable();
            new OleDbDataAdapter("Select * from Invoices", con).Fill(dt);

            //Configure the FlexPivotPanel
            C1FlexPivotPanel c1FlexPivotPanel = new C1FlexPivotPanel();
            c1FlexPivotPanel.DataSource = dt;
            c1FlexPivotPanel.FlexPivotEngine.RowFields.Add("Country");
            c1FlexPivotPanel.FlexPivotEngine.ColumnFields.Add("ProductName");
            c1FlexPivotPanel.FlexPivotEngine.FilterFields.Add("OrderDate");
            c1FlexPivotPanel.FlexPivotEngine.ValueFields.Add("ExtendedPrice");

            //Sets the data source for the FlexPivotGrid and FlexPivotChart
            c1FlexPivotGrid1.DataSource = c1FlexPivotPanel;
            c1FlexPivotChart1.DataSource = c1FlexPivotPanel;

            countrySlicer.Field = c1FlexPivotPanel.FlexPivotEngine.Fields["Country"]; //Sets the field which needs to be filtered by the FlexPivotSlicer
            productNameSlicer.Field = c1FlexPivotPanel.FlexPivotEngine.Fields["ProductName"]; //Sets the field which needs to be filtered by the FlexPivotSlicer
            productNameSlicer.Field.Caption = "Product Name";         
            productNameSlicer.MultiSelect = true;  //Allows users to select multiple items from the list

            orderMonthSlicer.Field = c1FlexPivotPanel.FlexPivotEngine.Fields["OrderDate"]; //Sets the field which needs to be filtered by the FlexPivotSlicer           
            //Customizes the field settings
            orderMonthSlicer.Field.Caption = "Month";
            orderMonthSlicer.Field.Format = "MMMM yyyy";

            orderMonthSlicer.MultiSelect = true;  //Allows users to select multiple items from the list
            orderMonthSlicer.SortOrder = System.Data.SqlClient.SortOrder.Descending; //Sorts the list in descending order
            orderMonthSlicer.ShowSort = true; //Displays the Sort button in the header 

            //Styling the FlexPivotSlicer          
            countrySlicer.Styles.Header.Font = new Font(FontFamily.GenericSansSerif,10,FontStyle.Bold);
            productNameSlicer.Styles.Header.Font = new Font(FontFamily.GenericSansSerif, 10, FontStyle.Bold);
            orderMonthSlicer.Styles.Header.Font = new Font(FontFamily.GenericSansSerif, 10, FontStyle.Bold);

            //Additional settings (Optional)
            c1FlexPivotGrid1.Rows.DefaultSize = 35;
            panel1.BackColor = Color.LightSteelBlue;
        }

        private void showGrid_Click(object sender, EventArgs e)
        {
            c1FlexPivotChart1.Visible = false;
            c1FlexPivotGrid1.Visible = true;
        }

        private void showChart_Click(object sender, EventArgs e)
        {
            c1FlexPivotChart1.Visible = true;
            c1FlexPivotGrid1.Visible = false;
        }
    }
}
